#include <descrip.h>
#include <ssdef.h>

#include "sha256.h"

#include "tim.h"
#include "syi.h"
#include "dvi.h"
#include "jpi.h"
#include "cnt.h"
#include "hsh.h"

#include "extran.h"

long int get_extran_data(char *buf, long int flag)
{
    char tmp[10000];
    int tmplen = 0;
    $DESCRIPTOR(sysdsk, "SYS$SYSDEVICE");
    $DESCRIPTOR(usrdsk, "SYS$DISK");
    SHA256_CTX ctx;
    if(flag & (EXTRAN_SYI + EXTRAN_DVI_SYS + EXTRAN_DVI_USR + EXTRAN_JPI))
    {
        if(flag & EXTRAN_TIM)
        {
            tmplen += get_tim_data(tmp + tmplen, sizeof(tmp) - tmplen);
        }
        if(flag & EXTRAN_SYI)
        {
            tmplen += get_syi_data(tmp + tmplen, sizeof(tmp) - tmplen);
        }
        if(flag & EXTRAN_DVI_SYS)
        {
            tmplen += get_dvi_data(&sysdsk, tmp + tmplen, sizeof(tmp) - tmplen);
        }
        if(flag & EXTRAN_DVI_USR)
        {
            tmplen += get_dvi_data(&usrdsk, tmp + tmplen, sizeof(tmp) - tmplen);
        }
        if(flag & EXTRAN_JPI)
        {
            tmplen += get_jpi_data(0, tmp + tmplen, sizeof(tmp) - tmplen);
        }
        if(flag & EXTRAN_CNT)
        {
            tmplen += get_cnt_data(tmp + tmplen, sizeof(tmp) - tmplen);
        }
        if(flag & EXTRAN_HSH)
        {
            tmplen += get_hsh_data(tmp, tmplen, tmp + tmplen, sizeof(tmp) - tmplen);
        }
    }
    else
    {
        return SS$_BADPARAM;
    }
    sha256_init(&ctx);
    sha256_update(&ctx, (unsigned char *)tmp, tmplen);
    sha256_final(&ctx, (unsigned char *)buf);
    return SS$_NORMAL;
}

